<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetResponseByIssuerTranIdResponse StructType
 * @subpackage Structs
 */
class GetResponseByIssuerTranIdResponse extends AbstractStructBase
{
    /**
     * The outIssuerTranId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $outIssuerTranId;
    /**
     * The outMerchantTranId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outMerchantTranId;
    /**
     * The outAuthorizationCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outAuthorizationCode;
    /**
     * The outTranDateTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outTranDateTime;
    /**
     * The outCafeteriaCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outCafeteriaCode;
    /**
     * The outIssuerReversalTranId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $outIssuerReversalTranId;
    /**
     * The outResponseCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outResponseCode;
    /**
     * The outResponseMessage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outResponseMessage;
    /**
     * The outTransactionStatus
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $outTransactionStatus;
    /**
     * Constructor method for GetResponseByIssuerTranIdResponse
     * @uses GetResponseByIssuerTranIdResponse::setOutIssuerTranId()
     * @uses GetResponseByIssuerTranIdResponse::setOutMerchantTranId()
     * @uses GetResponseByIssuerTranIdResponse::setOutAuthorizationCode()
     * @uses GetResponseByIssuerTranIdResponse::setOutTranDateTime()
     * @uses GetResponseByIssuerTranIdResponse::setOutCafeteriaCode()
     * @uses GetResponseByIssuerTranIdResponse::setOutIssuerReversalTranId()
     * @uses GetResponseByIssuerTranIdResponse::setOutResponseCode()
     * @uses GetResponseByIssuerTranIdResponse::setOutResponseMessage()
     * @uses GetResponseByIssuerTranIdResponse::setOutTransactionStatus()
     * @param int $outIssuerTranId
     * @param string $outMerchantTranId
     * @param string $outAuthorizationCode
     * @param string $outTranDateTime
     * @param string $outCafeteriaCode
     * @param int $outIssuerReversalTranId
     * @param string $outResponseCode
     * @param string $outResponseMessage
     * @param string $outTransactionStatus
     */
    public function __construct($outIssuerTranId = null, $outMerchantTranId = null, $outAuthorizationCode = null, $outTranDateTime = null, $outCafeteriaCode = null, $outIssuerReversalTranId = null, $outResponseCode = null, $outResponseMessage = null, $outTransactionStatus = null)
    {
        $this
            ->setOutIssuerTranId($outIssuerTranId)
            ->setOutMerchantTranId($outMerchantTranId)
            ->setOutAuthorizationCode($outAuthorizationCode)
            ->setOutTranDateTime($outTranDateTime)
            ->setOutCafeteriaCode($outCafeteriaCode)
            ->setOutIssuerReversalTranId($outIssuerReversalTranId)
            ->setOutResponseCode($outResponseCode)
            ->setOutResponseMessage($outResponseMessage)
            ->setOutTransactionStatus($outTransactionStatus);
    }
    /**
     * Get outIssuerTranId value
     * @return int|null
     */
    public function getOutIssuerTranId()
    {
        return $this->outIssuerTranId;
    }
    /**
     * Set outIssuerTranId value
     * @param int $outIssuerTranId
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutIssuerTranId($outIssuerTranId = null)
    {
        // validation for constraint: int
        if (!is_null($outIssuerTranId) && !(is_int($outIssuerTranId) || ctype_digit($outIssuerTranId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($outIssuerTranId, true), gettype($outIssuerTranId)), __LINE__);
        }
        $this->outIssuerTranId = $outIssuerTranId;
        return $this;
    }
    /**
     * Get outMerchantTranId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutMerchantTranId()
    {
        return isset($this->outMerchantTranId) ? $this->outMerchantTranId : null;
    }
    /**
     * Set outMerchantTranId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outMerchantTranId
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutMerchantTranId($outMerchantTranId = null)
    {
        // validation for constraint: string
        if (!is_null($outMerchantTranId) && !is_string($outMerchantTranId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outMerchantTranId, true), gettype($outMerchantTranId)), __LINE__);
        }
        if (is_null($outMerchantTranId) || (is_array($outMerchantTranId) && empty($outMerchantTranId))) {
            unset($this->outMerchantTranId);
        } else {
            $this->outMerchantTranId = $outMerchantTranId;
        }
        return $this;
    }
    /**
     * Get outAuthorizationCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutAuthorizationCode()
    {
        return isset($this->outAuthorizationCode) ? $this->outAuthorizationCode : null;
    }
    /**
     * Set outAuthorizationCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outAuthorizationCode
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutAuthorizationCode($outAuthorizationCode = null)
    {
        // validation for constraint: string
        if (!is_null($outAuthorizationCode) && !is_string($outAuthorizationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outAuthorizationCode, true), gettype($outAuthorizationCode)), __LINE__);
        }
        if (is_null($outAuthorizationCode) || (is_array($outAuthorizationCode) && empty($outAuthorizationCode))) {
            unset($this->outAuthorizationCode);
        } else {
            $this->outAuthorizationCode = $outAuthorizationCode;
        }
        return $this;
    }
    /**
     * Get outTranDateTime value
     * @return string|null
     */
    public function getOutTranDateTime()
    {
        return $this->outTranDateTime;
    }
    /**
     * Set outTranDateTime value
     * @param string $outTranDateTime
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutTranDateTime($outTranDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($outTranDateTime) && !is_string($outTranDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outTranDateTime, true), gettype($outTranDateTime)), __LINE__);
        }
        $this->outTranDateTime = $outTranDateTime;
        return $this;
    }
    /**
     * Get outCafeteriaCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutCafeteriaCode()
    {
        return isset($this->outCafeteriaCode) ? $this->outCafeteriaCode : null;
    }
    /**
     * Set outCafeteriaCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outCafeteriaCode
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutCafeteriaCode($outCafeteriaCode = null)
    {
        // validation for constraint: string
        if (!is_null($outCafeteriaCode) && !is_string($outCafeteriaCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outCafeteriaCode, true), gettype($outCafeteriaCode)), __LINE__);
        }
        if (is_null($outCafeteriaCode) || (is_array($outCafeteriaCode) && empty($outCafeteriaCode))) {
            unset($this->outCafeteriaCode);
        } else {
            $this->outCafeteriaCode = $outCafeteriaCode;
        }
        return $this;
    }
    /**
     * Get outIssuerReversalTranId value
     * @return int|null
     */
    public function getOutIssuerReversalTranId()
    {
        return $this->outIssuerReversalTranId;
    }
    /**
     * Set outIssuerReversalTranId value
     * @param int $outIssuerReversalTranId
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutIssuerReversalTranId($outIssuerReversalTranId = null)
    {
        // validation for constraint: int
        if (!is_null($outIssuerReversalTranId) && !(is_int($outIssuerReversalTranId) || ctype_digit($outIssuerReversalTranId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($outIssuerReversalTranId, true), gettype($outIssuerReversalTranId)), __LINE__);
        }
        $this->outIssuerReversalTranId = $outIssuerReversalTranId;
        return $this;
    }
    /**
     * Get outResponseCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutResponseCode()
    {
        return isset($this->outResponseCode) ? $this->outResponseCode : null;
    }
    /**
     * Set outResponseCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outResponseCode
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutResponseCode($outResponseCode = null)
    {
        // validation for constraint: string
        if (!is_null($outResponseCode) && !is_string($outResponseCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outResponseCode, true), gettype($outResponseCode)), __LINE__);
        }
        if (is_null($outResponseCode) || (is_array($outResponseCode) && empty($outResponseCode))) {
            unset($this->outResponseCode);
        } else {
            $this->outResponseCode = $outResponseCode;
        }
        return $this;
    }
    /**
     * Get outResponseMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutResponseMessage()
    {
        return isset($this->outResponseMessage) ? $this->outResponseMessage : null;
    }
    /**
     * Set outResponseMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outResponseMessage
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutResponseMessage($outResponseMessage = null)
    {
        // validation for constraint: string
        if (!is_null($outResponseMessage) && !is_string($outResponseMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outResponseMessage, true), gettype($outResponseMessage)), __LINE__);
        }
        if (is_null($outResponseMessage) || (is_array($outResponseMessage) && empty($outResponseMessage))) {
            unset($this->outResponseMessage);
        } else {
            $this->outResponseMessage = $outResponseMessage;
        }
        return $this;
    }
    /**
     * Get outTransactionStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOutTransactionStatus()
    {
        return isset($this->outTransactionStatus) ? $this->outTransactionStatus : null;
    }
    /**
     * Set outTransactionStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $outTransactionStatus
     * @return \StructType\GetResponseByIssuerTranIdResponse
     */
    public function setOutTransactionStatus($outTransactionStatus = null)
    {
        // validation for constraint: string
        if (!is_null($outTransactionStatus) && !is_string($outTransactionStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outTransactionStatus, true), gettype($outTransactionStatus)), __LINE__);
        }
        if (is_null($outTransactionStatus) || (is_array($outTransactionStatus) && empty($outTransactionStatus))) {
            unset($this->outTransactionStatus);
        } else {
            $this->outTransactionStatus = $outTransactionStatus;
        }
        return $this;
    }
}
